DCMTK: dcmtk::log4cplus::FileAppender Class Reference

DCMTK Version 3.6.9 OFFIS DICOM Toolkit

Loading...
Searching...
No Matches
Public Member Functions | Protected Attributes | List of all members
dcmtk::log4cplus::FileAppender Class Reference

Appends log events to a file. More...

Inheritance diagram for dcmtk::log4cplus::FileAppender:

## Public Member Functions
virtual STD_NAMESPACE locale | imbue (STD_NAMESPACE locale const &loc)
| Redefine default locale for output stream.
virtual STD_NAMESPACE locale | getloc () const
Public Member Functions inherited from dcmtk::log4cplus::Appender
void | doAppend (const log4cplus::spi::InternalLoggingEvent &event)
| This method performs threshold checks and invokes filters before delegating actual logging to the subclasses specific `append` method.
virtual log4cplus::tstring | getName ()
| Get the name of this appender.
virtual void | setName (const log4cplus::tstring &name)
| Set the name of this appender.
virtual void | setErrorHandler (OFunique_ptr< ErrorHandler > eh)
| Set the `ErrorHandler` for this Appender.
virtual ErrorHandler * | getErrorHandler ()
| Return the currently set `ErrorHandler` for this Appender.
virtual void | setLayout (OFunique_ptr< Layout > layout)
| Set the layout for this appender.
virtual Layout * | getLayout ()
| Returns the layout of this appender.
void | setFilter (log4cplus::spi::FilterPtr f)
| Set the filter chain on this Appender.
log4cplus::spi::FilterPtr | getFilter () const
| Get the filter chain on this Appender.
LogLevel | getThreshold () const
| Returns this appenders threshold LogLevel.
void | setThreshold (LogLevel th)
| Set the threshold LogLevel.
bool | isAsSevereAsThreshold (LogLevel ll) const
| Check whether the message LogLevel is below the appender's threshold.

## Protected Attributes
bool | immediateFlush
| Immediate flush means that the underlying writer or output stream will be flushed at the end of each append operation.
int | reopenDelay
| When any append operation fails, `reopenDelay` says for how many seconds the next attempt to re-open the log file and resume logging will be delayed.
Protected Attributes inherited from dcmtk::log4cplus::Appender
OFunique_ptr< Layout > | layout
| The layout variable does not need to be set if the appender implementation has its own layout.
log4cplus::tstring | name
| Appenders are named.
LogLevel | threshold
| There is no LogLevel threshold filtering by default.
log4cplus::spi::FilterPtr | filter
| The first filter in the filter chain.
OFunique_ptr< ErrorHandler > | errorHandler
| It is assumed and enforced that errorHandler is never null.
OFunique_ptr< helpers::LockFile > | lockFile
| Optional system wide synchronization lock.
bool | useLockFile
| Use lock file for inter-process synchronization of access to log file.
bool | closed
| Is this appender closed?

## Detailed Description

Appends log events to a file.

### Properties

`File`

  This property specifies output file name.

`ImmediateFlush`

  When it is set true, output stream will be flushed after each appended event.

`Append`

  When it is set true, output file will be appended to instead of being truncated at opening.

`ReopenDelay`

  This property sets a delay after which the appender will try to reopen log file again, after last logging failure.

`BufferSize`

  Non-zero value of this property sets up buffering of output stream using a buffer of given size.

`UseLockFile`
  Set this property to `true` if you want your output to go into a log file shared by multiple processes. When this property is set to true then log4cplus uses OS specific facilities (e.g., `lockf()`) to provide inter-process file locking.
  See also
    Appender
`LockFile`
  This property specifies lock file, file used for inter-process synchronization of log file access. When this property is not specified, the value is derived from `File` property by addition of ".lock" suffix. The property is only used when `UseLockFile` is set to true.
  See also
    Appender
`Locale`
  This property specifies a locale name that will be imbued into output stream. Locale can be specified either by system specific locale name, e.g., `en_US.UTF-8`, or by one of four recognized keywords: `GLOBAL`, `DEFAULT` (which is an alias for `GLOBAL`), `USER` and `CLASSIC`. When specified locale is not available, `GLOBAL` is used instead. It is possible to register additional locale keywords by registering an instance of `spi::LocaleFactory` in `spi::LocaleFactoryRegistry`.
  See also
    spi::getLocaleFactoryRegistry()

## Member Function Documentation

## ◆ getloc()

virtual STD_NAMESPACE locale dcmtk::log4cplus::FileAppender::getloc | ( |  | ) | const
| virtual

Returns
  Locale imbued in fstream.

## ◆ imbue()

virtual STD_NAMESPACE locale dcmtk::log4cplus::FileAppender::imbue | ( | STD_NAMESPACE locale const & | loc | ) |
| virtual

Redefine default locale for output stream.

It may be a good idea to provide UTF-8 locale in case UNICODE macro is defined.

## Member Data Documentation

## ◆ immediateFlush

bool dcmtk::log4cplus::FileAppender::immediateFlush
| protected

Immediate flush means that the underlying writer or output stream will be flushed at the end of each append operation.

Immediate flush is slower but ensures that each append request is actually written. If `immediateFlush` is set to `false`, then there is a good chance that the last few logs events are not actually written to persistent media if and when the application crashes.

The `immediateFlush` variable is set to `true` by default.

## ◆ reopenDelay

int dcmtk::log4cplus::FileAppender::reopenDelay
| protected

When any append operation fails, `reopenDelay` says for how many seconds the next attempt to re-open the log file and resume logging will be delayed.

If `reopenDelay` is zero, each failed append operation will cause log file to be re-opened. By default, `reopenDelay` is 1 second.

The documentation for this class was generated from the following file:

- oflog/include/dcmtk/oflog/fileap.h

Generated on Wed Apr 30 2025 for DCMTK Version 3.6.9 by Doxygen 1.13.2